# cAvatar Class Reference

Inheritance diagram for cAvatar:

List of all members.

## Classes

struct | ModelChange
struct | PaletteChange
struct | TextureChange

## Public Member Functions

| cAvatar (cLocation *pcLoc=NULL)
| cAvatar (DWORD guid, cLocation *pcLoc=NULL)
cMessage | Portal (DWORD dwLandblock, float flX, float flY, float flZ, float flA, float flW)
DWORD | GetHealValue (DWORD dwLevel)
DWORD | GetStaminaValue (DWORD dwLevel)
float | GetRegenIncValue (DWORD dwLevel)
float | GetRegenDecValue (DWORD dwLevel)
float | GetProtValue (DWORD dwLevel)
float | GetVulnValue (DWORD dwLevel)
float | GetArmorValue (DWORD dwLevel)
float | GetTransferValue (DWORD dwLevel)
cMessage | LocationPacket ()
cMessage | SetPosition ()
void | SetOptions (DWORD optionsMask)
cMessage | Particle (DWORD dwParticleID)
cMessage | Animation (WORD wAnim, float flPlaySpeed=1.0f)
cMessage | WarAnim (WORD wAnim, float flPlaySpeed=1.0f)
cMessage | SoundEffect (DWORD dwSound, float flPlaySpeed=1.0f)
cMessage | CreatePacket ()
cMessage | CreateLoginPacket (DWORD F7B0seq)
cMessage | SetPackContents (DWORD F7B0seq)
cMessage | AllegianceInfo (DWORD F7B0seq)
cMessage | HousingInfo (DWORD F7B0seq)
cMessage | LoginCharacter ()
void | LogoutCharacter ()
void | Assess (cClient *pcAssesser)
void | Action (cClient *who)
cMessage | ChangeCombatMode (BOOL fMode, BYTE WieldType)
cMessage | ChangeSpellMode (BOOL fMode)
cMessage | ChangeMissileMode (BOOL fMode, WORD AmmoType)
float | GetRange (DWORD dwLandblock, float flX, float flY, float flZ, DWORD dwTargetLandblock, float flTarX, float flTarY, float flTarZ)
float | GetHeadingTarget (DWORD dwLandblock, float flX, float flY, float flZ, DWORD dwTargetLandblock, float flTarX, float flTarY, float flTarZ)
cMessage | RunToAnimation (DWORD dwGUID, DWORD dwTarget)
cMessage | CombatAnimation (DWORD dwTarget)
cMessage | TurnToTarget (float flHeading, DWORD dwTargetGUID)
cMessage | DoDamageMessage (DWORD F7B0seq, std::string target, DWORD damagetype, double severity, DWORD amount)
cMessage | RecieveDamageMessage (DWORD F7B0seq, std::string giver, DWORD damagetype, double severity, DWORD amount, DWORD location)
cMessage | DecrementHealth (WORD amount, signed int &newhealth)
cMessage | DecrementStamina (WORD amount, signed int &newstamina)
cMessage | DecrementMana (WORD amount, signed int &newmana)
cMessage | AddEnchant (DWORD F7B0seq, DWORD dwSpellID, WORD wEnchantLayer, WORD wSpellFamily, DWORD dwDifficulty, double dDuration, DWORD dwCasterGUID, double dTime, DWORD dwFlags, DWORD dwKey, float flValue)
cMessage | RemoveEnchant (DWORD F7B0seq, DWORD dwSpellID, WORD wEnchantLayer)
void | UpdateHuntingExp (DWORD amount)
void | UpdateFellowshipExp (DWORD amount)
cMessage | UpdateUnassignedExp (DWORD amount)
cMessage | UpdateTotalExp (DWORD amount)
cMessage | UpdateSkillExp (DWORD amount, BYTE skill)
cMessage | UpdateLevel ()
cMessage | UpdateBurden (DWORD amount, int action)
cMessage | UpdateRank (DWORD amount)
cMessage | UpdatePyreals (DWORD amount, int positive)
cMessage | UpdateDeaths (DWORD amount)
cMessage | UpdateAge (DWORD amount)
cMessage | DecrementUnassignedExp (DWORD amount)
cMessage | UpdateStrength (DWORD exp)
cMessage | UpdateEndurance (DWORD exp)
cMessage | UpdateQuickness (DWORD exp)
cMessage | UpdateCoordination (DWORD exp)
cMessage | UpdateFocus (DWORD exp)
cMessage | UpdateSelf (DWORD exp)
void | CalcVital (WORD vitalID)
cMessage | RaiseHealth (DWORD exp)
cMessage | RaiseStamina (DWORD exp)
cMessage | RaiseMana (DWORD exp)
cMessage | AdjustHealthBar (DWORD dwGUID, DWORD F7B0Sequence)
void | CalcSkill (DWORD skillID)
cMessage | UpdateSkill (DWORD skillID, DWORD exp)
cMessage | AttackCompleteMessage (DWORD F7B0seq)
cMessage | AttackBeginMessage (DWORD F7B0seq, DWORD pcGUID)
cMessage | SetHealth (DWORD dwNewHealth)
cMessage | SetStamina (DWORD dwNewStamina)
cMessage | SetMana (DWORD dwNewMana)
cMessage | UpdateHealth (WORD amount, signed int &newvalue)
cMessage | UpdateStamina (WORD amount, signed int &newvalue)
cMessage | UpdateMana (WORD amount, signed int &newvalue)
cMessage | HouseAbandon (DWORD F7B0seq)
void | HouseGuestAdd (char strGuestName[50])
void | HouseGuestRemoveName (char strGuestName[50])
void | HouseOpenClose (DWORD IsOpen)
void | HouseStorage (char strGuestName[50], DWORD dwStorageSet)
void | HouseBootName (char strGuestName[50])
void | HouseStorageRemoveAll ()
cMessage | HouseGuestList (DWORD F7B0seq)
DWORD | CalculateDamage (cObject *pcWeapon, float flPower, float flResistance)
cMessage | WindupAnimation (WORD wAnim1, float flPlaySpeed)
cMessage | WarAnimation (WORD wAnim1, float flPlaySpeed)
cMessage | WarAnimation2 (float flPlaySpeed)
void | SetLifestone (cLocation myLifestone)
cMessage | LifestoneRecall ()
cMessage | LSAnimate ()
cMessage | LSMessage ()
cMessage | MarketplaceRecall ()
cMessage | MPAnimate ()
cMessage | MPMessage ()
cMessage | HouseRecall ()
cMessage | HRAnimate ()
cMessage | HRMessage ()
cMessage | ConfirmPanelRequest (DWORD F7B0seq, DWORD type, DWORD ConfirmSeq, std::string targetName)
void | SetIsPK_DB ()
DWORD | GetAllegianceID ()
DWORD | GetFellowshipID ()
WORD | GetGender ()
WORD | GetRace ()
WORD | GetRank ()
DWORD | GetTotalStrength ()
DWORD | GetTotalEndurance ()
DWORD | GetTotalQuickness ()
DWORD | GetTotalCoordination ()
DWORD | GetTotalFocus ()
DWORD | GetTotalSelf ()
WORD | GetTotalHealth ()
WORD | GetTotalStamina ()
WORD | GetTotalMana ()
WORD | GetTotalLoyalty ()
WORD | GetTotalLeadership ()
void | SetAllegianceID (DWORD newAllegianceID)
void | SetFellowshipID (DWORD newFellowshipID)
void | UpdateQuestCompletedTable (DWORD dwAvatarGUID, DWORD quest_id)
void | SaveToDB ()
void | UpdateAllegianceDB ()
void | UpdateAvatarLocation ()
void | AddItemToInvDB (DWORD dwAvatarGUID, cObject *pcObject)
void | DeleteItemFromInvDB (DWORD dwAvatarGUID, cObject *pcObject)
void | UpdateUnassignedXPDB (cClient *who, DWORD exp)
void | UpdateTotalXPDB (cClient *who, DWORD exp)
void | UpdateLevelDB (cClient *who)
cMessage | UpdateAvatarPalette ()
cMessage | UpdateAvatarTexture ()
cMessage | UpdateAvatarModel ()
DWORD | GetAllegianceFromDB ()
void | BreakAllegiance ()
void | SwearAllegiance (std::string szTargetName, DWORD dwReply, DWORD dwSenderGUID)
void | SwearAllegianceReply (std::string szTargetName, DWORD dwReply)
void | BreakAllegiance (DWORD dwMemberGUID)
void | BreakAllegianceReply (std::string szMemberName)
void | CreateFellowship (DWORD F7B0Sequence, char strFellowName[50])
void | DisbandFellowship ()
void | OpenCloseFellowship (DWORD dwOpen)
void | FellowshipLeader (DWORD dwNewLeaderGUID)
void | FellowshipRecruitSend (std::string szTargetName, DWORD dwReply, DWORD dwReceiptGUID)
void | FellowshipRecruitRecv (std::string szTargetName, DWORD dwReply, DWORD dwSenderGUID)
void | FellowshipDismiss (DWORD dwMemberGUID)
DWORD | AwardTotalExp (DWORD txpamount)
DWORD | AwardUnassignedXP (DWORD uxpamount)
int | SpendUnassignedXP (int uxpamount)
int | AddBurden (int amount)
int | RemoveBurden (int amount)
DWORD | AddPyreals (DWORD amount)
DWORD | RemovePyreals (DWORD amount)
int | EatStaminaFood (int amount)
int | ALDamageReduction (DWORD alvalue)
void | SetCombatTarget (cObject *pcObject)
void | AddInventory (cObject *pcObject)
void | RemoveInventory (cObject *pcObject)
cObject * | FindInventory (DWORD dwGUID)
DWORD | SetArmorLevel (DWORD AL)
DWORD | GetLevel (DWORD totalxp)
void | DeleteFromInventory (cObject *pcObject)
void | CreateChildren (cClient *pcClientDestination)

## Static Public Member Functions

static int | CastMain (LPVOID wp, LPVOID lp)
static int | WarAnimation1 (LPVOID wp, LPVOID lp)
static int | WarAnimation2 (LPVOID wp, LPVOID lp)
static int | WarAnimation3 (LPVOID wp, LPVOID lp)
static void | CastWar (LPVOID wp)
static void | CastLife (LPVOID wp)
static void | CastCreature (LPVOID wp)
static void | CastItem (LPVOID wp)

## Public Attributes

float | m_flTargetHeading
WORD | m_wCurAnim
WORD | m_wMeleeSequence
WORD | m_wPortalCount
WORD | m_wMoveCount
BYTE | m_bStatSequence
WORD | m_wModelSequenceType
WORD | m_wModelSequence
WORD | m_wModelNum
float | m_flAScale
BYTE | m_bAccessLevel
WORD | m_wState
DWORD | m_dwPingCount
WORD | m_wLifeStone
WORD | m_wMarketplace
WORD | m_wHouseRecall
WORD | m_wHouseID
WORD | m_wPKlite
WORD | m_wTimedEvent
DWORD | m_dwNumFollowers
DWORD | m_dwNumDeaths
BYTE | m_bFlagCount
WORD | m_wSpellCount
DWORD | m_dwSpellUnknown
cSpellBook | m_SpellBook [100]
cSpellTab | m_SpellTabs [7]
DWORD | m_dwInventoryCount
cInventory | m_Inventory [300]
vInventory | m_vInventory [300]
DWORD | m_InvGUIDs [300]
cLocation | m_PreviousLocation
cStats | m_cStats
BYTE | m_fIsPK
DWORD | m_CorpseTarget
DWORD | m_DmgTypeEquipped
bool | inFellow
DWORD | m_dwOptions
std::list< cObject * > | m_lstInventory
std::string | sAccount_Name
cWeapon * | myWeapon
cShield * | myShield
cAmmo * | myAmmo

## Friends

class | cAllegiance
class | cClient
class | cDatabase
class | cFellowship
class | cPortalDat
class | cCommandParser
class | cMonsterServer
class | cNPC
class | cWorldManager
class | cWeapon
class | cWorldServer

## Member Function Documentation

void cAvatar::Assess | ( | cClient * | pcAssesser | ) | `[virtual]`

Handles the assessment of avatars.

This function is called whenever an avatar is assessed by another client. Returns a Game Event (0x0000F7B0) server message of type Identify Object (0x000000C9).

Reimplemented from cObject.

void cAvatar::CalcSkill | ( | DWORD | skillID | ) |

Calculates the total base value of a skill.

The base value will be equal to the creation value plus creation bonus (if trained or specialized) plus skill increments plus any attribute bonus to the skill. The resultant value is used for server-side calculations; the client maintains its own value (which should match the server's value).

Parameters:

  | skillID | - The numeric representation of the skill.

void cAvatar::CalcVital | ( | WORD | vitalID | ) |

Calculates the total base value of a vital (Health, Stamina, Mana).

The base value will be equal to the creation valu plus increments to the vital. The resultant value is used for server-side calculations; the client maintains its own value (which should match the server's value).

Parameters:

  | vitalID | - The numeric representation of the skill.

void cAvatar::CastCreature | ( | LPVOID | wp | ) | `[static]`

Handles the message sent for the casting of a Creature Enchantment spell.

This function is called whenever a Creature Enchantment spell is cast by a client's avatar. Returns a server message to the client.

void cAvatar::CastItem | ( | LPVOID | wp | ) | `[static]`

Handles the message sent for the casting of an Item Enchantment spell.

This function is called whenever an Item Enchantment spell is cast by a client's avatar. Returns a server message to the client.

void cAvatar::CastLife | ( | LPVOID | wp | ) | `[static]`

Handles the message sent for the casting of a Life Magic spell.

This function is called whenever a Life Magic spell is cast by a client's avatar. Returns a server message to the client.

void cAvatar::CastWar | ( | LPVOID | wp | ) | `[static]`

Handles the message sent for the casting of a War Magic spell.

This function is called whenever a War Magic spell is cast by a client's avatar. Returns a server message to the client.

cMessage cAvatar::CombatAnimation | ( | DWORD | dwTarget | ) |

Handles the message sent for the avatar's animation when combating.

Returns:
  cMessage - Returns an Animation (0x0000F74C) server message.

void cAvatar::CreateFellowship | ( | DWORD | F7B0Sequence,
|  | char | strFellowName[50] |
| ) |  |  |

Handles the creation of a fellowship.

Parameters:

  | F7B0Sequence | - The client's present F7B0 sequence value.
  | strFellowName | - The fellowship's name.

cMessage cAvatar::CreateLoginPacket | ( | DWORD | F7B0seq | ) |

Handles the message sent for the login of an avatar.

The message includes information on name, race, sex, class, levels, attributes, vitals, skills, experience, deaths, burden, pyreals, spelltabs, inventory, and equipment. The function uses information loaded by cDatabase::LoadAvatarList.

See also:
  cDatabase::LoadAvatarList

Returns:
  cMessage - Returns a Game Event (0x0000F7B0) server message of type Login Character (0x00000013).

cMessage cAvatar::CreatePacket | ( |  | ) | `[virtual]`

Handles the message sent for the creation of an avatar.

The message includes information on the avatar's model (palette, texture, and model information), name, icon, PK flag, inventory slots, pack slots, and total pyreals value.

Returns:
  cMessage - Returns a Create Object (0x0000F745) server message.

Implements cObject.

cMessage cAvatar::DecrementHealth | ( | WORD | amount,
|  | signed int & | newhealth |
| ) |  |  |

Handles the message sent when an avatar's Health vital is decremented.

Parameters:

  | amount | - The amount of Health to decrement.
  | &newHealth | - The address of an integer that will represent the avatar's new Health

Returns:
  cMessage - Returns an Update Vital Statistic (0x00000244) server message.

cMessage cAvatar::DecrementMana | ( | WORD | amount,
|  | signed int & | newmana |
| ) |  |  |

Handles the message sent when an avatar's Mana vital is decremented.

Parameters:

  | amount | - The amount of Mana to decrement.
  | &newmana | - The address of an integer that will represent the avatar's new Mana

Returns:
  cMessage - Returns an Update Vital Statistic (0x00000244) server message.

cMessage cAvatar::DecrementStamina | ( | WORD | amount,
|  | signed int & | newstamina |
| ) |  |  |

Handles the message sent when an avatar's Stamina vital is decremented.

Parameters:

  | amount | - The amount of Stamina to decrement.
  | &newstamina | - The address of an integer that will represent the avatar's new Stamina

Returns:
  cMessage - Returns an Update Vital Statistic (0x00000244) server message.

cMessage cAvatar::DecrementUnassignedExp | ( | DWORD | amount | ) |

Handles the message sent to the avatar when experience is decremented from the unassigned experience value.

Parameters:

  | amount | - The amount of experience to decrement.

Returns:
  cMessage - Returns an Update Statistic (0x00000237) server message.

void cAvatar::DisbandFellowship | ( |  | ) |

Handles the quitting from or disbanding of a fellowship.

void cAvatar::FellowshipDismiss | ( | DWORD | dwMemberGUID | ) |

Removes a character from the fellowship and relays the relevant messages.

Parameters:

  | dwMemberGUID | - The GUID of the character to remove.

void cAvatar::FellowshipLeader | ( | DWORD | dwNewLeaderGUID | ) |

Promotes a character to fellowship leader and relays the relevant messages.

Parameters:

  | dwNewLeaderGUID | - The GUID of the character to promote.

void cAvatar::FellowshipRecruitRecv | ( | std::string | szTargetName,
|  | DWORD | dwReply,
|  | DWORD | dwSenderGUID |
| ) |  |  |

Encapsulates messages sent to receiver after an offer of fellowship is accepted or declined.

Parameters:

  | szTargetName | - The sending character's name.
  | dwReply | - The reply (yes/no) to the offer of fellowship.
  | dwSenderGUID | - The sending character's GUID.

void cAvatar::FellowshipRecruitSend | ( | std::string | szTargetName,
|  | DWORD | dwReply,
|  | DWORD | dwReceiptGUID |
| ) |  |  |

Encapsulates messages sent to sender after an offer of fellowship is accepted or declined.

Parameters:

  | szTargetName | - The target character's name.
  | dwReply | - The reply (yes/no) to the offer of fellowship.
  | dwReceiptGUID | - The target character's GUID.

float cAvatar::GetArmorValue | ( | DWORD | dwLevel | ) |

Determines the increase in Armor Level after an Invulnerability spell

This function is called whenever an Invulnerability spell is cast

Parameters:

  | dwLevel | - The level of the Invulnerability Spell

Returns:
  flValue - The increase in Armor Level by the spell

DWORD cAvatar::GetHealValue | ( | DWORD | dwLevel | ) |

Determines the heal amount of a Heal spell.

This function is called whenever a Heal spell is cast

Parameters:

  | dwLevel | - The level of the Heal Spell

Returns:
  dwHeal - The amount of Health healed by the spell

float cAvatar::GetProtValue | ( | DWORD | dwLevel | ) |

Determines the damage percentage after a Protection spell

This function is called whenever a Protection spell is cast

Parameters:

  | dwLevel | - The level of the Protection Spell

Returns:
  flValue - The new damage percentage for the damage type with the spell

float cAvatar::GetRegenDecValue | ( | DWORD | dwLevel | ) |

Determines the rate of vital replenishment after a Fester spell.

This function is called whenever a Fester spell is cast

Parameters:

  | dwLevel | - The level of the Fester Spell

Returns:
  flValue - The new rate of regeneration for the vital with the spell

float cAvatar::GetRegenIncValue | ( | DWORD | dwLevel | ) |

Determines the rate of vital replenishment after a Regeneration spell.

This function is called whenever a Regeneration spell is cast

Parameters:

  | dwLevel | - The level of the Regeneration Spell

Returns:
  flValue - The new rate of regeneration for the vital with the spell

DWORD cAvatar::GetStaminaValue | ( | DWORD | dwLevel | ) |

Determines the infused amount of an Infuse Stamina spell.

This function is called whenever an Infuse Stamina spell is cast

Parameters:

  | dwLevel | - The level of the Infuse Stamina Spell

Returns:
  dwStamina - The amount of Stamina infused by the spell

float cAvatar::GetTransferValue | ( | DWORD | dwLevel | ) |

Determines the amount of vital transferred by a Vital to Vital spell

This function is called whenever a Vital to Vital spell is cast

Parameters:

  | dwLevel | - The level of the Vital to Vital Spell

Returns:
  flValue - The percentage of vital transferred by the spell

float cAvatar::GetVulnValue | ( | DWORD | dwLevel | ) |

Determines the damage percentage after a Vulnerability spell

This function is called whenever a Vulnerability spell is cast

Parameters:

  | dwLevel | - The level of the Vulnerability Spell

Returns:
  flValue - The new damage percentage for the damage type with the spell

cMessage cAvatar::HouseAbandon | ( | DWORD | F7B0seq | ) |

Handles the message sent for an avatar's housing information. Also updates the respective database entries.

Returns:
  cMessage - Returns a Game Event (0x0000F7B0) server message of type House Information for Non-Owners (0x00000226).

void cAvatar::HouseGuestAdd | ( | char | strGuestName[50] | ) |

Adds a guest to the avatar's house guest list database entries.

Parameters:

  | strGuestName | - The name of the guest to add.

cMessage cAvatar::HouseGuestList | ( | DWORD | F7B0seq | ) |

Handles the message sent for an avatar's housing guest list.

Returns:
  cMessage - Returns a Game Event (0x0000F7B0) server message of type House Guest List (0x00000257).

void cAvatar::HouseGuestRemoveName | ( | char | strGuestName[50] | ) |

Removes a guest from the avatar's house guest list database entries.

Parameters:

  | strGuestName | - The name of the guest to remove.

void cAvatar::HouseOpenClose | ( | DWORD | dwIsOpen | ) |

The open/closed value of the avatar's house database entry.

Parameters:

  | dwIsOpen | - A value representing whether the house is now open or closed.

cMessage cAvatar::HouseRecall | ( |  | ) |

Handles the message sent for an avatar's recall to a house.

Returns:
  cMessage - Returns a Toggle Object Visibility (0x0000F74B) server message.

void cAvatar::HouseStorage | ( | char | strGuestName[50],
|  | DWORD | dwStorageSet |
| ) |  |  |

Updates the storage permission for a guess on the avatar's house guest list database entries.

Parameters:

  | strGuestName | - The name of the guest to whose permissions should be modified.
  | dwStorageSet | - A value representing whether access to storage is permitted or revoked.

void cAvatar::HouseStorageRemoveAll | ( |  | ) |

Removes all guests on the avatar's house guest list database entries.

cMessage cAvatar::HousingInfo | ( | DWORD | F7B0seq | ) |

Handles the message sent for an avatar's housing information.

The message includes information on the house's purchase time, type,purchase and maintaince costs, name, and location.

Returns:
  cMessage - Returns a Game Event (0x0000F7B0) server message of type House Information for Owners (0x00000225) or House Information for Non-Owners (0x00000226).

cMessage cAvatar::HRAnimate | ( |  | ) |

Handles the message sent for the avatar's animation when recalling to a house.

Returns:
  cMessage - Returns an Animation (0x0000F74C) server message.

cMessage cAvatar::HRMessage | ( |  | ) |

Handles the message sent for the server text when recalling to a house.

Returns:
  cMessage - Returns a Server Text (0x0000F62C) server message.

cMessage cAvatar::LifestoneRecall | ( |  | ) |

Handles the message sent for an avatar's recall to a lifestone.

Returns:
  cMessage - Returns a Toggle Object Visibility (0x0000F74B) server message.

cMessage cAvatar::LSAnimate | ( |  | ) |

Handles the message sent for the avatar's animation when recalling to a lifestone.

Returns:
  cMessage - Returns an Animation (0x0000F74C) server message.

cMessage cAvatar::LSMessage | ( |  | ) |

Handles the message sent for the server text when recalling to a lifestone.

Returns:
  cMessage - Returns a Server Text (0x0000F62C) server message.

cMessage cAvatar::MarketplaceRecall | ( |  | ) |

Handles the message sent for an avatar's recall to the Marketplace.

Returns:
  cMessage - Returns a Toggle Object Visibility (0x0000F74B) server message.

cMessage cAvatar::MPAnimate | ( |  | ) |

Handles the message sent for the avatar's animation when recalling to the Marketplace.

Returns:
  cMessage - Returns an Animation (0x0000F74C) server message.

cMessage cAvatar::MPMessage | ( |  | ) |

Handles the message sent for the server text when recalling to the Marketplace.

Returns:
  cMessage - Returns a Server Text (0x0000F62C) server message.

void cAvatar::OpenCloseFellowship | ( | DWORD | dwOpen | ) |

Sets a fellowship open or closed and relays the relevant messages.

Parameters:

  | dwOpen | - Determines whether the fellowship is opened or closed (0 = closed; 1 = opened).

cMessage cAvatar::RaiseHealth | ( | DWORD | exp | ) |

Handles the message sent when an avatar's Health vital is incremented. Also updates the database value.

Parameters:

  | exp | - The amount of experience spent incrementing Health.

Returns:
  cMessage - Returns an Update Secondary Attribute (0x00000243) server message.

cMessage cAvatar::RaiseMana | ( | DWORD | exp | ) |

Handles the message sent when an avatar's Mana vital is incremented. Also updates the database value.

Parameters:

  | exp | - The amount of experience spent incrementing Mana.

Returns:
  cMessage - Returns an Update Secondary Attribute (0x00000243) server message.

cMessage cAvatar::RaiseStamina | ( | DWORD | exp | ) |

Handles the message sent when an avatar's Stamina vital is incremented. Also updates the database value.

Parameters:

  | exp | - The amount of experience spent incrementing Stamina.

Returns:
  cMessage - Returns an Update Secondary Attribute (0x00000243) server message.

cMessage cAvatar::RemoveEnchant | ( | DWORD | F7B0seq,
|  | DWORD | dwSpellID,
|  | WORD | wEnchantLayer |
| ) |  |  |

Handles the message sent to the avatar when a spell timer expires.

Returns:
  cMessage - Returns an 0x0000F7B0 server message.

cMessage cAvatar::RunToAnimation | ( | DWORD | dwGUID,
|  | DWORD | dwTarget |
| ) |  |  |

Handles the message sent for the avatar's animation when running towards a combat target.

Returns:
  cMessage - Returns an Animation (0x0000F74C) server message.

void cAvatar::SaveToDB | ( |  | ) |

Updates the database record of the avatar.

Parameters:

  | *who | - A pointer to the client whose avatar's database record should be updated.

cMessage cAvatar::SetHealth | ( | DWORD | dwNewHealth | ) |

Handles the message sent when an avatar's Health vital is changed.

Parameters:

  | dwNewHealth | - The new Health value.

Returns:
  cMessage - Returns an Update Vital Statistic (0x00000244) server message.

cMessage cAvatar::SetMana | ( | DWORD | dwNewMana | ) |

Handles the message sent when an avatar's Mana vital is changed.

Parameters:

  | dwNewMana | - The new Mana value.

Returns:
  cMessage - Returns an Update Vital Statistic (0x00000244) server message.

cMessage cAvatar::SetPosition | ( |  | ) | `[virtual]`

Handles the message sent for the updating of an avatar's location.

Returns:
  cMessage - Returns an 0x0000F748 server message.

Reimplemented from cObject.

cMessage cAvatar::SetStamina | ( | DWORD | dwNewStamina | ) |

Handles the message sent when an avatar's Stamina vital is changed.

Parameters:

  | dwNewStamina | - The new Stamina value.

Returns:
  cMessage - Returns an Update Vital Statistic (0x00000244) server message.

cMessage cAvatar::TurnToTarget | ( | float | flHeading,
|  | DWORD | dwTargetGUID |
| ) |  |  | `[virtual]`

Handles the message sent for the avatar's animation when turning towards a combat target.

Returns:
  cMessage - Returns an Animation (0x0000F74C) server message.

Reimplemented from cObject.

void cAvatar::UpdateAvatarLocation | ( |  | ) |

Updates the database value of the avatar's location.

cMessage cAvatar::UpdateBurden | ( | DWORD | amount,
|  | int | action |
| ) |  |  |

Handles the message sent when an avatar's burden amount changes.

Parameters:

  | amount | - The amount of burden to add or remove.
  | positive | - Whether the amount should add or remove burden.

Returns:
  cMessage - Returns an Update Statistic (0x00000237) server message.

cMessage cAvatar::UpdateCoordination | ( | DWORD | exp | ) |

Handles the message sent when an avatar's Coordination attribute is incremented. Also updates the database value.

Parameters:

  | exp | - The amount of experience spent incrementing Coordination.

Returns:
  cMessage - Returns an Update Attribute (0x00000241) server message.

cMessage cAvatar::UpdateEndurance | ( | DWORD | exp | ) |

Handles the message sent when an avatar's Endurance attribute is incremented. Also updates the database value.

Parameters:

  | exp | - The amount of experience spent incrementing Endurance.

Returns:
  cMessage - Returns an Update Attribute (0x00000241) server message.

void cAvatar::UpdateFellowshipExp | ( | DWORD | amount | ) |

Handles the message sent to the avatar when experience is awarded through a fellowship.

Parameters:

  | amount | - The amount of experience to award.

cMessage cAvatar::UpdateFocus | ( | DWORD | exp | ) |

Handles the message sent when an avatar's Focus attribute is incremented. Also updates the database value.

Parameters:

  | exp | - The amount of experience spent incrementing Focus.

Returns:
  cMessage - Returns an Update Attribute (0x00000241) server message.

cMessage cAvatar::UpdateHealth | ( | WORD | amount,
|  | signed int & | newvalue |
| ) |  |  |

Handles the message sent when an avatar's Health vital is updated by an item (food, drink, potion, etc).

Parameters:

  | amount | - The amount by which the avatar's Health should increase.
  | &newvalue | - The address of an integer that will represent the avatar's new Health

Returns:
  cMessage - Returns an Update Vital Statistic (0x00000244) server message.

void cAvatar::UpdateHuntingExp | ( | DWORD | amount | ) |

Handles the message sent to the avatar when experience is awarded to the unassigned experience value.

Parameters:

  | amount | - The amount of experience to award.

cMessage cAvatar::UpdateLevel | ( |  | ) |

Updates the avatar's level.

The level is calculated based upon a formula that uses the avatar's total experience. Whether to award a skill credit is determined based upon pre-defined table entries.

The resultant value is used for server-side calculations; the client maintains its own value (which should match the server's value).

void cAvatar::UpdateLevelDB | ( | cClient * | who | ) |

Updates the database value of the avatar's level.

Parameters:

  | *who | - A pointer to the client whose avatar's level value should be updated.
  | exp | - The present level value.

cMessage cAvatar::UpdateMana | ( | WORD | amount,
|  | signed int & | newvalue |
| ) |  |  |

Handles the message sent when an avatar's Mana vital is updated by an item (food, drink, potion, etc).

Parameters:

  | amount | - The amount by which the avatar's Mana should increase.
  | &newvalue | - The address of an integer that will represent the avatar's new Mana

Returns:
  cMessage - Returns an Update Vital Statistic (0x00000244) server message.

cMessage cAvatar::UpdatePyreals | ( | DWORD | amount,
|  | int | positive |
| ) |  |  |

Handles the message sent when an avatar's pyreal amount changes.

Parameters:

  | amount | - The amount of pyreals to add or remove.
  | positive | - Whether the amount is positive or negative

Returns:
  cMessage - Returns an Update Statistic (0x00000237) server message.

cMessage cAvatar::UpdateQuickness | ( | DWORD | exp | ) |

Handles the message sent when an avatar's Quickness attribute is incremented. Also updates the database value.

Parameters:

  | exp | - The amount of experience spent incrementing Quickness.

Returns:
  cMessage - Returns an Update Attribute (0x00000241) server message.

cMessage cAvatar::UpdateSelf | ( | DWORD | exp | ) |

Handles the message sent when an avatar's Self attribute is incremented. Also updates the database value.

Parameters:

  | exp | - The amount of experience spent incrementing Self.

Returns:
  cMessage - Returns an Update Attribute (0x00000241) server message.

cMessage cAvatar::UpdateSkill | ( | DWORD | skillID,
|  | DWORD | exp |
| ) |  |  |

Handles the message sent when an avatar increments a skill. Also updates the database value.

Parameters:

  | skillID | - The numeric representation of the skill. The function generically switches depending upon the skillID.
  | exp | - The amount of experience spent incrementing the skill.

Returns:
  cMessage - Returns a Skill Experience (0x0000023E) server message.

cMessage cAvatar::UpdateSkillExp | ( | DWORD | amount,
|  | BYTE | skill |
| ) |  |  |

Handles the message sent to the avatar when experience is awarded to skill experience value.

Parameters:

  | amount | - The amount of experience to award.
  | skill | - The skill to which the experience is awarded.

Returns:
  cMessage - Returns an Update Statistic (0x00000237) server message.

cMessage cAvatar::UpdateStamina | ( | WORD | amount,
|  | signed int & | newvalue |
| ) |  |  |

Handles the message sent when an avatar's Stamina vital is updated by an item (food, drink, potion, etc).

Parameters:

  | amount | - The amount by which the avatar's Stamina should increase.
  | &newvalue | - The address of an integer that will represent the avatar's new Stamina

Returns:
  cMessage - Returns an Update Vital Statistic (0x00000244) server message.

cMessage cAvatar::UpdateStrength | ( | DWORD | exp | ) |

Handles the message sent when an avatar's Strength attribute is incremented. Also updates the database value.

Parameters:

  | exp | - The amount of experience spent incrementing Strength.

Returns:
  cMessage - Returns an Update Attribute (0x00000241) server message.

cMessage cAvatar::UpdateTotalExp | ( | DWORD | amount | ) |

Handles the message sent to the avatar when experience is awarded to the total experience value.

Parameters:

  | amount | - The amount of experience to award.

Returns:
  cMessage - Returns an Update Statistic (0x00000237) server message.

void cAvatar::UpdateTotalXPDB | ( | cClient * | who,
|  | DWORD | exp |
| ) |  |  |

Updates the database value of the avatar's total experience.

Parameters:

  | *who | - A pointer to the client whose avatar's total experience value should be updated.
  | exp | - The present total experience value.

cMessage cAvatar::UpdateUnassignedExp | ( | DWORD | amount | ) |

Handles the message sent to the avatar when experience is awarded to the unassigned experience value.

Parameters:

  | amount | - The amount of experience to award.

Returns:
  cMessage - Returns an Update Statistic (0x00000237) server message.

void cAvatar::UpdateUnassignedXPDB | ( | cClient * | who,
|  | DWORD | exp |
| ) |  |  |

Updates the database value of the avatar's unassigned experience.

Parameters:

  | *who | - A pointer to the client whose avatar's unassigned experience value should be updated.
  | exp | - The present unassigned experience value.

cMessage cAvatar::WarAnimation | ( | WORD | wAnim1,
|  | float | flPlaySpeed |
| ) |  |  |

Handles the message sent for the avatar's animation when casting a war spell.

Returns:
  cMessage - Returns an Animation (0x0000F74C) server message.

cMessage cAvatar::WarAnimation2 | ( | float | flPlaySpeed | ) |

Handles the message sent for the avatar's animation when casting a war spell.

Returns:
  cMessage - Returns an Animation (0x0000F74C) server message.

The documentation for this class was generated from the following files:

- E:/uas2/Server/Avatar.h
- E:/uas2/Server/Avatar.cpp